function changeExistingDiagram(){
    $('change-existing-diagram-form').setStyles({
       'display':'block',
       'height':'auto',
       'width':'auto' 
    });
}

function displayExistingDiagram(imagePath,startEl){
    
    var imagezoom = new Imagezoom({
        image: imagePath,
        startElement: $(startEl)
    });
    
    imagezoom.preloadImage();
    imagezoom.show();
    
}

function clickableDiagramZones(){
    if(!$("diagram-readonly")) {return;}
    
	$$("#diagram-readonly .diagram-zone").each(function(zone){
        
        if(zone.dataset.count == 0){
            zone.setStyle('cursor','default');
        } else {
            zone.addEvent('click',function(ev){
                var e     = new Event(ev);
                var link  = zone.dataset.url;
            
                window.open(link,"_self",false);
            });
        }
        
	});
    
}

function activateDiagramZones(){
	if(!$("diagram-zones")) {return;}
	
	$$("#diagram-zones .diagram-zone").each(function(e){
		e.makeDraggable({'container':$("diagram-zones"),'onComplete':function(e){
			saveDiagramZoneCoordinates(e);
		}});
	});
	
}

function activateDiagramZoneTriggers(){
    
    if(!$("diagram-zone-associations-inventory")) {return;}
    
    $$('.diagram-zone-active').each(function(zone){
       
       zone.addEvent('mouseenter',function(ev){
           var e        = new Event(ev);
           var id       = parse_id(zone.id);
           var viewer   = buildDiagramZoneViewer(id,zone);
      
           if(viewer){
               viewer.inject('diagram-zones-viewer');
               viewer.reveal();
           }
      
       });
        
    });
    
}

function buildDiagramZoneViewer(zoneId,zone){
    
    var sourceId = "diagram-zone-association-" + zoneId; 
    var clone    = $(sourceId).clone();
    
    if(clone.getChildren().length == 0){
        clone.destroy();
        return null;
    }
    
    var zoneLeft = zone.getStyle('left');
    var zoneTop  = zone.getStyle('top');
    var id       = "diagram-zone-viewer-" + zoneId;
    
    var view     = new Element('div',{
        'id':id,
        'class':'diagram-zone-viewer',
        'styles':{
            'opacity':0,
            'top':zoneTop,
            'left':zoneLeft
        }
    });
    
    view.revealMorph = new Fx.Morph(view,{
        'duration':'short'
    })
    
    view.hideMorph   = new Fx.Morph(view,{
        'duration':'short',
        'link':'chain',
        'onComplete':function(){
            this.destroy();
        }.bind(view)
    })
    
    view.reveal      = function(){
        
        $$('.diagram-zone-viewer').each(function(viewer){
           if(viewer != view){
               viewer.hide();
           } 
        });
        
        
        view.revealMorph.start({
            'opacity':1
        })        
    }
    
    view.hide        = function(){
        view.hideMorph.start({
            'opacity':0
        })
    }
    
    view.addEvent('mouseleave',function(ev){
       var e = new Event(ev);
            
       view.hide(); 
    });
    
    
    clone.inject(view);
    
    return view;
}

function saveDiagramZoneCoordinates(zone){
	
	var x = zone.getStyle('left').toInt();
	var y = zone.getStyle('top').toInt();
	
	var id_x  = zone.id + "_x";
	var id_y  = zone.id + "_y";
	
	$(id_x).value = x;
	$(id_y).value = y;
	
}

function activatePreviewButtons(){
	$$('.preview-button').each(function(e){
		activatePreviewButton(e);
	});
}

function activatePreviewButton(button){
	button.addEvent('click',function(ev){
		ev = new Event(ev);
		ev.stop();
		
		var url  = new Url(this.form.action);
		
		if(is_digit(url.path_components.getLast())){
			url = url.path + "/preview";
		} else {
			url = url.path + "/new/preview";
		}
	
		this.form.method = "post";
		this.form.action = url;
		this.form.submit();
	})
}

function activateScrambledSentences(){
	$$('.scrambled-sentence-question').each(function(e){
		e.sortable = new Sortables(e,{
		    onComplete:function(el){
		        parent      = el.getParent();
		        id          = parse_id(parent.id);
		        exercise_id = "exercise["+ id +"]";
		        
		        codes       = parent.sortable.serialize().map(function(item,index){
		           comp = Array.from(item.split('-'));
		           return comp.getLast();
		        });
		        
		        $(exercise_id).value = codes.join('-');
		    }
		});
	});
}

function activateGaps(){
	$$('.gap-item').each(function(e){
	   e.drag = new Drag.Ghost(e,{
	      droppables: '.gap-empty',
	      
	      onDrop:function(el,droppable,event){
	          if(droppable){
	              
	              	droppable.setStyle('color','#000');
              		droppable.set('html',el.innerHTML);

              		var gap_id  = el.id.split('-').getLast();
              		var drop_id = parse_id(droppable.id);

              		$('exercise_' + drop_id).value = gap_id;
	              
	          }
	      }
	       
	   });
	});
}

function activateFilter(){
    
    length = 1;
    
    if(fElem = $('quick-search-form')){
        fElem.addEvent('submit',function(){
           if(filterElem = $('filter')){
               if(filterElem.value.length < length){
                   alert("Your search query must be at least " + length + " character!");
                   return false;
               }
           }
           return true;
        });
    }
}
